﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
' REL 22/10/2021
#Event: ItemClick (Position As Int, Value as Object)
#Event: OpenList
#Event: FocusChanged (HasFocus As Boolean)

#DesignerProperty: Key: Editable, DisplayName: Editable text, FieldType: Boolean, DefaultValue: False, Description: Text Field Editable
#DesignerProperty: Key: Corner, DisplayName: Rounded Corner, FieldType: Int, DefaultValue: 0, MinRange: 0, MaxRange: 50, Description: Rounded corner
#DesignerProperty: Key: CornerColor, DisplayName: CornerColor Color, FieldType: Color, DefaultValue: 0xFF000000, Description: CornerColor color
#DesignerProperty: Key: Background, DisplayName: Background Color, FieldType: Color, DefaultValue: 0xFFFFFFFF, Description: Background color
#DesignerProperty: Key: RTL, DisplayName: Right to Left, FieldType: Boolean, DefaultValue: False, Description: Write Right to Left
#DesignerProperty: Key: Style, DisplayName: View Style, FieldType: String, DefaultValue: Frame, List: Frame|Bead|Classic
#DesignerProperty: Key: TextAlign, DisplayName: Text Alignment, FieldType: String, DefaultValue: CENTER, List: LEFT|CENTER|RIGHT
#DesignerProperty: Key: Align, DisplayName: Item Alignment, FieldType: String, DefaultValue: CENTER, List: LEFT|CENTER|RIGHT

Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	
	Private outListPanel As B4XView
	Private ListPanel As B4XView
	Private ListItem As List
	Private SelIndex As Int 
	Private FindIndex As Int = -1
	
	Private Editable As Boolean
	Private Corner As Int
	Private Style As String = "Frame"
	Private Align As String = "CENTER"
	Private TextAlign As String = "LEFT"
	Private ModIntern As Boolean=False
	Private BClr As Int
	Private RTL As Boolean = False
	Private LabelHint As B4XView
	Private MyLabel As B4XView
	Private CornerColor As Int
	
	Private kbh As Int = 0
	Public ItemHeight As Int
	Public OpenDropDownOnFocus As Boolean
	Public SelectOnlyFromList As Boolean = False
	
	#IF B4A
	Private kk As IME
	#End If
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	
	outListPanel=xui.CreatePanel("outListPanel")
	#If B4A
	Dim Sc As ScrollView
	Sc.Initialize2(1000dip,"Sc")
	ListPanel=Sc
	
	kk.Initialize("kk")
	kk.AddHeightChangedEvent
	#Else IF B4i
	Dim Sc As ScrollView
	Sc.Initialize("Sc",500dip,100dip)
	ListPanel=Sc
	#Else if B4j
	Dim Sc As ScrollPane
	Sc.Initialize("Sc")
	Sc.SetHScrollVisibility("NEVER")
	Sc.SetVScrollVisibility("NEVER")
	ListPanel=Sc
	#End If
	
	LabelHint=CreateLabel("LabelHint")
	
	ListItem.Initialize
	SelIndex=-1
	
	ItemHeight=40dip
	OpenDropDownOnFocus=True
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
	Tag = mBase.Tag
	mBase.Tag = Me
	
	If Props.ContainsKey("RTL") Then RTL=Props.Get("RTL")
	If Props.ContainsKey("Style") Then Style=Props.Get("Style")
	If Props.ContainsKey("Align") Then Align=Props.Get("Align")
	If Props.ContainsKey("TextAlign") Then TextAlign=Props.Get("TextAlign")
	If Props.ContainsKey("CornerColor") Then CornerColor=xui.PaintOrColorToColor(Props.Get("CornerColor")) Else CornerColor=MyLabel.TextColor
	If Props.ContainsKey("Background") Then	BClr=xui.PaintOrColorToColor(Props.Get("Background")) Else BClr=mBase.Color
	If Props.ContainsKey("Editable") Then Editable=Props.Get("Editable")
	Corner=Props.Get("Corner")
	Corner=Corner*(100dip/100)
	
	#IF B4J
	mBase.As(Pane).Style="-fx-border-radius:0.00;-fx-background-radius:0.00;-fx-border-width:0.00;"
	#ELSE IF B4i
	ListPanel.As(ScrollView).Bounces=False
	#End If
	
	If Editable Then MyLabel=CreateTextView("MyLabel") Else MyLabel=CreateLabel("MyLabel")
	
	MyLabel.TextColor=Lbl.As(B4XView).TextColor
	MyLabel.TextSize=Lbl.As(B4XView).TextSize
	MyLabel.Font=Lbl.As(B4XView).Font
	If Editable = False Then MyLabel.SetTextAlignment("CENTER",TextAlign)
	MyLabel.Color=xui.Color_Transparent
	MyLabel.Text=Lbl.As(B4XView).Text
	If Editable Then MyLabel.EditTextHint="<none>"

	LabelHint.Text=Chr(0xF006) 'lbx.EditTextHint
	LabelHint.TextColor=MyLabel.TextColor
	LabelHint.Color=xui.Color_Transparent
	LabelHint.SetTextAlignment("CENTER","CENTER")
	LabelHint.Font=xui.CreateFontAwesome(MyLabel.Font.Size)

	Select Style
		Case "Frame"
			mBase.SetColorAndBorder(BClr,1dip,CornerColor,Corner)
		Case "Bead"
			LabelHint.TextColor=BClr
			LabelHint.SetColorAndBorder(CornerColor,0dip,xui.Color_Transparent,20dip)
			
			Dim Can As B4XCanvas
			Dim Rec As B4XRect
			
			Can.Initialize(mBase)
			Rec.Initialize(20dip,mBase.Height/2,mBase.Width-20dip,mBase.Height)
			Can.DrawRect(Rec,CornerColor,True,0dip)
			If RTL Then
				Dim Rec As B4XRect
				Rec.Initialize(0dip,0dip,mBase.Width-45dip,mBase.Height-1dip)
				Dim Path As B4XPath
				Path.InitializeRoundedRect(Rec,20dip)
				Can.DrawPath(Path,BClr,True,0dip)
			Else
				Dim Rec As B4XRect
				Rec.Initialize(45dip,0dip,mBase.Width,mBase.Height-1dip)
				Dim Path As B4XPath
				Path.InitializeRoundedRect(Rec,20dip)
				Can.DrawPath(Path,BClr,True,0dip)
			End If
			Can.Invalidate
		Case "Classic"
			LabelHint.SetTextAlignment("CENTER","CENTER")
			LabelHint.Font=xui.CreateDefaultBoldFont(MyLabel.Font.Size-3)
			LabelHint.Text="Set Hint"
	End Select
	
	If Style="Classic" Then		
		mBase.AddView(MyLabel,0dip,30dip,mBase.Width,mBase.Height-30dip)
		mBase.AddView(LabelHint,5dip,0dip,mBase.Width-10dip,30dip)
		MyLabel.SetColorAndBorder(BClr,1dip,CornerColor,Corner)
		If RTL Then
			MyLabel.SetTextAlignment("CENTER","RIGHT")
			LabelHint.SetTextAlignment("CENTER","RIGHT")
			#IF B4J
			MyLabel.As(JavaObject).RunMethod("setAlignment", Array As Object("CENTER_RIGHT"))
			#ELSE IF B4A
			MyLabel.As(JavaObject).RunMethod("setPadding", Array As Object(5dip, 0dip, 5dip, 0dip))
			#END IF
		Else
			MyLabel.SetTextAlignment("CENTER","LEFT")
			LabelHint.SetTextAlignment("CENTER","LEFT")
			#IF B4J
			MyLabel.As(JavaObject).RunMethod("setAlignment", Array As Object("CENTER_LEFT"))
			#ELSE IF B4A
			MyLabel.As(JavaObject).RunMethod("setPadding", Array As Object(5dip, 0dip, 5dip, 0dip))
			#END IF
		End If
	Else
		If RTL Then
			mBase.AddView(LabelHint,mBase.Width-45dip,0dip,40dip,mBase.Height)
			mBase.AddView(MyLabel,5dip,0dip,mBase.Width-50dip,mBase.Height)
		#IF B4J
			MyLabel.As(JavaObject).RunMethod("setAlignment", Array As Object("CENTER_RIGHT"))
		#ELSE IF B4i
			MyLabel.SetTextAlignment("CENTER","RIGHT")
		#ELSE IF B4A
			MyLabel.SetTextAlignment("CENTER","RIGHT")
			MyLabel.As(JavaObject).RunMethod("setPadding", Array As Object(5dip, 0dip, 5dip, 0dip))
		#End If
		Else
			mBase.AddView(LabelHint,5dip,0dip,40dip,mBase.Height)
			mBase.AddView(MyLabel,50dip,0dip,mBase.Width-50dip,mBase.Height)
		#IF B4J
			MyLabel.As(JavaObject).RunMethod("setAlignment", Array As Object("CENTER_LEFT"))
		#ELSE
			MyLabel.SetTextAlignment("CENTER","LEFT")
		#End If
		End If
	End If
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	If Style="Classic" Then
		MyLabel.Width=Width-10dip
		MyLabel.Height=Height-30dip
		LabelHint.Width=Width
	Else
		If RTL Then
			MyLabel.Width=Width-50dip
			MyLabel.Height=Height
			LabelHint.Left=Width-45dip
			LabelHint.Height=Height
		Else
			MyLabel.Width=Width-50dip
			MyLabel.Height=Height
			LabelHint.Height=Height
		End If
	End If
	
	#IF B4I
	ListPanel.As(ScrollView).ContentWidth=mBase.Width-3dip
	#end if
End Sub

Public Sub GetBase As B4XView
	Return mBase
End Sub


 #Region Method
 
Public Sub setHint(Text As String)
	LabelHint.Text=Text
End Sub

Public Sub getHint As String
	Return LabelHint.Text
End Sub

Public Sub setHintFont(Fnt As B4XFont)
	LabelHint.Font=Fnt
End Sub

Public Sub getHintFont As B4XFont
	Return LabelHint.Font
End Sub

'Public Sub setText(Text As String)
'	MyLabel.Text=Text
'End Sub
'
'Public Sub getText As String
'	Return MyLabel.Text
'End Sub

Public Sub setTextFont(Fnt As B4XFont)
	MyLabel.Font=Fnt
End Sub

Public Sub getTextFont As B4XFont
	Return MyLabel.Font
End Sub

Public Sub getSelectionStart As Int
	Return MyLabel.SelectionStart
End Sub

Public Sub getSelectionLength As Int
	Return MyLabel.SelectionLength
End Sub

Public Sub SetSelection(Start As Int, Length As Int)
	MyLabel.SetSelection(Start,Length)
End Sub
 
 Public Sub getComboText As String
 	Return MyLabel.Text
End Sub
 
 ' ----------------------------------------- METHOD COMBO ---------------------------
 
' Add Item
Public Sub Add(Text As String, ReturnValue As Object)
	Dim M As Map
	M.Initialize
	M.Put("Text",Text)
	M.Put("Value",ReturnValue)
	M.Put("object",Null)
	ListItem.Add(M)
	'ListItem.Add(CreateMap("Text":Text,"Value":ReturnValue))
End Sub

' Add List of Item, Return Value is a Text
Public Sub AddAll(L As List)
	For Each text As String In L
		Dim M As Map
		M.Initialize
		M.Put("Text",text)
		M.Put("Value",text)
		M.Put("object",Null)
		
		ListItem.Add(M)
		'ListItem.Add(CreateMap("Text":text,"Value":text,"object":Null))
	Next
End Sub
 
public Sub Size As Int
	Return ListItem.Size
End Sub

Public Sub Clear
	ListItem.Clear
	SelIndex=-1
	'MyLabel.Text="<none>"
	if Editable then  MyLabel.EditTextHint="<none>"
	MyLabel.Text=""
End Sub

Public Sub OpenDropDown
	#if B4I
	Sleep(10)
	#End If
	fixPanel
	DrawListBox
End Sub

Public Sub CloseDropDown
	outListPanel.RemoveViewFromParent
End Sub

Public Sub isDropDownOpen As Boolean
	Return (outListPanel.Parent.IsInitialized)
End Sub

Public Sub GetItem(Position As Int) As String
	Dim Ret As String = ""
	
	'If Editable Then Return MyLabel.Text
	If Position>-1 And Position<ListItem.Size Then
		Ret=ListItem.Get(Position).As(Map).Get("Text")
	End If
	Return Ret
End Sub

Public Sub GetValue(Position As Int) As Object
	Dim Ret As Object
	If Position=-1 And Editable Then Return MyLabel.Text
	If Position>-1 And Position<ListItem.Size Then
		Ret=ListItem.Get(Position).As(Map).Get("Value")
	End If
	
	Return Ret
End Sub

Public Sub getSelectedIndex As Int
	Return SelIndex
End Sub

Public Sub setSelectedIndex(Position As Int)
	If Position>-1 And Position<ListItem.Size Then
		SelIndex=Position
		MyLabel.Text=GetItem(Position)
		
		Dim Pos As Int = ItemHeight * Position
		 #if B4A
			ListPanel.As(ScrollView).ScrollPosition=Pos
		#else if B4I
			ListPanel.ScrollViewOffsetY=Pos
		#ELSE If B4J
			ListPanel.As(ScrollPane).VPosition=Pos/ListPanel.ScrollViewContentHeight
		#End If
	else if Position=-1 Then
		SelIndex=Position
		'MyLabel.Text=""
	End If
End Sub

Public Sub getSelectedTextItem As String
	Return  GetItem(SelIndex)
End Sub

Public Sub setSelectedTextItem(Value As String)
	If Editable Then 
		ModIntern=True
		MyLabel.Text=Value	
	Else
		For i=0 To ListItem.Size-1
			Dim v As Map = ListItem.Get(i)
			If Value = v.Get("Text") Then
				SelIndex=i
				MyLabel.Text=GetItem(I)
			End If
		Next
	End If
End Sub

Public Sub getSelectedValueItem As Object
	Return  GetValue(SelIndex)
End Sub

Public Sub setSelectedValueItem(Value As Object)
	If Editable Then
		ModIntern=True
		MyLabel.Text=Value
	Else
		For i=0 To ListItem.Size-1
			Dim v As Map = ListItem.Get(i)
			If Value = v.Get("Value") Then 
				SelIndex=i
				MyLabel.Text=GetItem(I)
			End If
		Next
	End If
End Sub

Public Sub getEnabled As Boolean
	Return MyLabel.Enabled
End Sub

Public Sub setEnabled(B As Boolean)
	MyLabel.Enabled=B
End Sub

#end region

#Region Event

Private Sub outListPanel_Click
	CloseDropDown
	outListPanel.RequestFocus
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSub2(mCallBack,mEventName & "_FocusChanged",False)
End Sub

Private Sub LabSelect_Click
	Dim L As B4XView = Sender
	Dim index As Int = L.Tag
	
	setSelectedIndex(index)
	Sleep(100)
	If xui.SubExists(mCallBack,mEventName & "_ItemClick",2) Then CallSubDelayed3(mCallBack,mEventName & "_ItemClick",index,GetValue(index))
	outListPanel.RemoveViewFromParent
End Sub

Private Sub MyLabel_Click
	OpenDropDown
	MyLabel.RequestFocus
End Sub

Private Sub MyLabel_FocusChanged (HasFocus As Boolean)
	If HasFocus And OpenDropDownOnFocus Then
		OpenDropDown
'	Else
'		Sleep(500)
'		CloseDropDown
	End If
	ModIntern=False
	
	If xui.SubExists(mCallBack,mEventName & "_FocusChanged",1) Then CallSub2(mCallBack,mEventName & "_FocusChanged",HasFocus)
End Sub

Private Sub MyLabel_BeginEdit
	MyLabel_FocusChanged(True)
End Sub

Private Sub MyLabel_Action
	'CloseDropDown
	SelectedItem(MyLabel.Text)
End Sub

Private Sub MyLabel_EnterPressed
	'CloseDropDown
	SelectedItem(MyLabel.Text)
End Sub

Private Sub MyLabel_EndEdit
	'CloseDropDown
	MyLabel_FocusChanged(False)
	
	SelectedItem(MyLabel.Text)
End Sub

Private Sub SelectedItem(Value As String)
	If xui.SubExists(mCallBack,mEventName & "_ItemClick",2) Then 
		If SelectOnlyFromList Then
			SelIndex=FindIndex
			MyLabel.Text=GetItem(SelIndex)
			CallSubDelayed3(mCallBack,mEventName & "_ItemClick",SelIndex,MyLabel.Text)
		Else
			CallSubDelayed3(mCallBack,mEventName & "_ItemClick",-1,Value)
		End If
	End If
	Sleep(100)
	outListPanel.RemoveViewFromParent
End Sub

Private Sub MyLabel_TextChanged (OldText As String, NewText As String)
	If ModIntern Then 
		ModIntern=False
		Return
	End If
	If OldText=NewText Then Return
	If isDropDownOpen=False And OpenDropDownOnFocus Then OpenDropDown
	FindIndex = -1

	For i=0 To ListItem.Size-1
		Dim v As Map = ListItem.Get(i)
		'If NewText = v.Get("Text") Then	FindIndex=I
		If v.Get("Text").As(String).ToLowerCase.IndexOf(NewText.ToLowerCase)>-1 Then
			FindIndex=i
			Exit
		End If
	Next
	
	If SelIndex>-1 And SelIndex<ListItem.Size Then
		If ListItem.Get(SelIndex).As(Map).Get("object").As(B4XView).IsInitialized Then 
			ListItem.Get(SelIndex).As(Map).Get("object").As(B4XView).Color=BClr
			ListItem.Get(SelIndex).As(Map).Get("object").As(B4XView).textColor=MyLabel.TextColor
		End If
	End If
			
	SelIndex=FindIndex
	If SelIndex>-1 And SelIndex<ListItem.Size Then
		If ListItem.Get(SelIndex).As(Map).Get("object").As(B4XView).IsInitialized Then
			ListItem.Get(SelIndex).As(Map).Get("object").As(B4XView).Color=MyLabel.TextColor
			ListItem.Get(SelIndex).As(Map).Get("object").As(B4XView).textColor=BClr
			
			'Log(StartVisible & " " & ListPanel.ScrollViewContentHeight & " " & ListPanel.Height & " " & StartPosition)
			Dim StartPosition As Int = ListItem.Get(SelIndex).As(Map).Get("object").As(B4XView).Top
			Dim EndPosition As Int = StartPosition + ListItem.Get(SelIndex).As(Map).Get("object").As(B4XView).Height
			Dim StartVisible As Int = ListPanel.ScrollViewOffsetY
			Dim EndVisible As Int = StartVisible + ListPanel.Height
			
			If Not((StartPosition>=StartVisible And StartPosition<EndVisible) And (EndPosition>StartVisible And EndPosition<=EndVisible)) Then 
				'Log(Startposition & " " & ListPanel.ScrollViewContentHeight & " " & ListPanel.Height)
				If StartPosition>ListPanel.ScrollViewContentHeight-ListPanel.Height Then 
					ListPanel.ScrollViewOffsetY=ListPanel.ScrollViewContentHeight-ListPanel.Height
				Else
					ListPanel.ScrollViewOffsetY=StartPosition
				End If
			End If
		End If
	End If
End Sub

#IF B4A

Private Sub kk_HeightChanged (NewHeight As Int, OldHeight As Int)
	kbh=NewHeight

	If isDropDownOpen Then 
		CloseDropDown
		fixPanel
		DrawListBox
	End If
End Sub

#ELSE IF B4J

Private Sub outListPanel_MouseClicked (EventData As MouseEvent)
	outListPanel_Click
End Sub

Private Sub Mylabel_MouseClicked (EventData As MouseEvent)
	MyLabel_Click
End Sub

Private Sub LabSelect_MouseClicked (EventData As MouseEvent)
	Dim L As B4XView = Sender
	Dim index As Int = L.Tag
	
	setSelectedIndex(index)
	Sleep(100)
	If xui.SubExists(mCallBack,mEventName & "_ItemClick",2) Then CallSubDelayed3(mCallBack,mEventName & "_ItemClick",index,GetValue(index))
	outListPanel.RemoveViewFromParent
End Sub

Private Sub ColorToHex(clr As Long) As String
	Dim r,g,b,a As Byte
	b=Bit.And(clr,0x000000FF) 'b
	g=Bit.ShiftRight(Bit.And(clr,0x0000FF00),8) 'g
	r=Bit.ShiftRight(Bit.And(clr,0x00FF0000),16) ' r
	a=Bit.ShiftRight(Bit.And(clr,0xFF000000),24) 'a
	
	
	Return Byte2Hex(r) & Byte2Hex(g) & Byte2Hex(b) & Byte2Hex(a)
End Sub

Private Sub Byte2Hex(b As Int) As String
	Dim hex As String = "0123456789ABCDEF"
	Dim l,h As Int
	l=Bit.And(b,0xf)
	h=Bit.And(Bit.ShiftRight(b,4),0xf)      ' <- safety fix
	Return (hex.CharAt(h) & hex.CharAt(l))
End Sub

#End If

#End Region

#Region function

Private Sub fixPanel
	Try
		Dim Left As Int = mBase.Left
		Dim Top As Int = mBase.top
		Dim width As Int 
		Dim height As Int
		Dim prec As B4XView = mBase
		Dim pnl As B4XView = mBase.Parent
		
		Do While (pnl.Parent.IsInitialized) And (GetType(pnl)<>"B4IMainView")
			'Log(GetType(pnl))
			Left=Left+pnl.Left
			Top=Top+pnl.Top
			prec=pnl
			pnl=pnl.Parent
		Loop
	Catch
		Log(LastException.Message)
	End Try
	If xui.IsB4i Then pnl=prec
	
	width=pnl.Width
	height=pnl.Height
	#If B4j
	If width=-1 Then width=mBase.Width
	If height=-1 Then height=mBase.Height
	#else
	If width=-1 Then width=100%x
	If height=-1 Then height=100%y	
	#End If
	
	outListPanel.Color=xui.Color_ARGB(5,5,5,5)
	outListPanel.RemoveViewFromParent
	pnl.AddView(outListPanel,0,0,width,height)
	
	If kbh>0 Then 
		height=kbh
	End If

	
	ListPanel.RemoveViewFromParent
	
	If Top+(mBase.Height/2)>height/2 Then
		' UP List
		outListPanel.AddView(ListPanel,Left,0,mBase.Width,Top)
	Else
		' down list
		outListPanel.AddView(ListPanel,Left,Top+mBase.Height,mBase.Width,outListPanel.Height-Top-mBase.Height-20dip)
	End If
End Sub

Private Sub DrawListBox
	Dim Height As Int = 0
	
	If xui.SubExists(mCallBack,mEventName & "_OpenList",0) Then CallSub(mCallBack,mEventName & "_OpenList")
	#if B4A or B4i
		ListPanel.As(ScrollView).Panel.RemoveAllViews
		ListPanel.Color=MyLabel.TextColor
	#ELSE If B4J
		ListPanel.As(ScrollPane).InnerNode.As(Pane).RemoveAllNodes
		ListPanel.As(ScrollPane).Style="-fx-background:#" & ColorToHex(CornerColor) & ";-fx-background-color:#" & ColorToHex(CornerColor) & ";"
	#End If
	
	For i=0 To ListItem.Size-1
		Dim v As Map = ListItem.Get(i)
		Dim L As B4XView = CreateLabel("LabSelect")
		L.Color=BClr
		L.TextColor=MyLabel.TextColor
		L.Text=v.Get("Text")
		L.SetTextAlignment("CENTER",Align)
		L.Tag=i
		v.Put("object",L)
		
		'ListPanel.AddView(L,0,Height,ListPanel.Width-2dip,ItemHeight)
		#if B4A or B4I
			ListPanel.As(ScrollView).Panel.AddView(L,1dip,Height,ListPanel.Width-2dip,ItemHeight-1dip)
		#ELSE If B4J
			ListPanel.As(ScrollPane).InnerNode.As(Pane).AddNode(L,0,Height,ListPanel.Width,ItemHeight-1dip)
		#End If
		
		Height=Height+ItemHeight
	Next
	
	#if B4A or B4I
		ListPanel.As(ScrollView).Panel.Height=Height
	#ELSE If B4J
		ListPanel.As(ScrollPane).InnerNode.As(Pane).PrefHeight=Height
	#End If
	
	ListPanel.ScrollViewContentHeight=Height
	If Height<ListPanel.Height Then 
		If ListPanel.Top=0 Then 
			ListPanel.top=ListPanel.Height-Height
		Else
			ListPanel.Height=Height
		End If
	End If
	If SelIndex>-1 Then 
		Sleep(0)
		setSelectedIndex(SelIndex)
	End If
End Sub

Private Sub CreateLabel(EventName As String) As B4XView
	Dim L As Label
	L.Initialize(EventName)
	Return L
End Sub

Private Sub CreateTextView(EventName As String) As B4XView
	#IF B4A
		Dim T As EditText
		T.Initialize(EventName)
	#ELSE IF B4J
		Dim T As TextField
		T.Initialize(EventName)
	#ELSE IF B4i
		Dim T As TextField
		T.Initialize(EventName)
	#End If
	Return T
End Sub

#End Region